/*
 Serial port driver software UART
  for 12F675/629 chips
 using software delays.
 Copyright (C)2008 Air_variable
 for use Hitech PICC PRO Lite mode ver9.60 Build2729 or higher

*/
#include	<htc.h>
//#include	<pic.h>
#include	<conio.h>

//RS232C̘_ _CNgڑ0,MAX232ChCoȂǐڑ1
#define sci_polarity 0 

/*	Xtal frequency */
#define MHz 000000
#define _XTAL_FREQ 4MHz

/*	Baud rate	*/

//{[[gݒ-{[[g9600bps19200bpsł̂ݓmF--------------
#define	BRATE	19200 
//e{[[gerror rate(1bit)
// 19200  52.083us -> 52us ( 99.84%)
//  9600 104.167us ->104us ( 99.84%)

//	Don't change anything elseJbgAhgCf[^
#define	TX_OHEAD	20		// overhead cycles per loop
#define	RX_OHEAD	12		// receiver overhead per loop 


//----------|[g̕ύX͂ōs܂-------------------------------
#if defined(_12F629)	|| defined(_12F675)
//	Transmit and Receive port bits
static bit	TxData @ ( (unsigned)&GPIO*8+5 );		/* bit5 in GPIO */
static bit	RxData @ ( (unsigned)&GPIO*8+3 );		/* bit3 in GPIO */
#define	INIT_PORT	TRISIO = 0x11011111 		/* set up I/O direction */

#else
//	Transmit and Receive port bits
static bit	TxData @ ( (unsigned)&PORTA*8+2 );		/* bit2 in PORTA */
static bit	RxData @ ( (unsigned)&PORTA*8+5 );		/* bit5 in PORTA */
#define	INIT_PORT	TRISA = 0x11111011 		/* set up I/O direction */

#endif
#define	DELAY(ohead)	(((_XTAL_FREQ/4/BRATE)-(ohead)))

void
putch(char c)
{
	unsigned char	dly, bitno;

	bitno = 11;

//	INIT_PORT;
#if sci_polarity
	TxData = 0;		// start bit sciɐ1̏ꍇ(ʏRS232C(max232c))
#else
	TxData = 1;		//* start bit sciɐ0̏ꍇ(Rɂ_CNgڑ
#endif

	bitno = 12;
	do {
		__delay_us( DELAY(TX_OHEAD));
		if(c & 1)

#if sci_polarity	//sciɐ1̏ꍇ(ʏRS232C(max232c))
			TxData = 1;
#else				//sciɐ0̏ꍇ(Rɂ_CNgڑ
			TxData = 0;
#endif
		if(!(c & 1))
#if sci_polarity	//sciɐ1̏ꍇ(ʏRS232C(max232c))
			TxData = 0;
#else				//sciɐ0̏ꍇ(Rɂ_CNgڑ
			TxData = 1;
#endif
		c = (c >> 1) | 0x80;
		
	} while(--bitno);
}

char
getch(void)
{
	unsigned char	c, bitno, dly;

	for(;;) {
#if sci_polarity
		while(RxData)	//max232c
#else 
		while(!RxData)	//_CNgڑ
#endif
			continue;	/* wait for start bit */

		__delay_us((DELAY(RX_OHEAD)/3));	//1/3 position

#if sci_polarity
		if(RxData)		//max232c
#else
		if(!RxData)		//_CNgڑ
#endif
			continue;	/* twas just noise */
		bitno = 8;
		c = 0;
		do {
			__delay_us( DELAY(RX_OHEAD));
			c = (c >> 1) | (RxData << 7);
		} while(--bitno);

#if sci_polarity
#else
		c=~c;	//_]
#endif

		return c;
	}
}
char
getche(void)
{
	char c;

	putch(c = getch());
	return c;
}


